<?php  /* ------ exemple de client CAS crit en PHP --------*/

  // localisation du serveur CAS
  define('CAS_BASE','https://cas.entmip.fr'');

  // propre URL
  $service = 'http://' . $_SERVER['SERVER_NAME'] . $_SERVER['REQUEST_URI'];

  /** Cette simple fonction ralise lauthentification CAS.
   * @return  le login de lutilisateur authentifi, ou FALSE.
   */
  function authenticate() {
      global $service ;

      // rcupration du ticket (retour du serveur CAS)
      if (!isset($_GET['ticket'])) {
          // pas de ticket : on redirige le navigateur web vers le serveur CAS
          header('Location: ' . CAS_BASE . '/login?service='  . $service);
          exit() ;
      }
      // un ticket a t transmis, on essaie de le valider auprs du serveur CAS
      $fpage = fopen (CAS_BASE . '/serviceValidate?service='
                               . preg_replace('/&/','%26',$service) . '&ticket=' . $ticket,  'r');
      if ($fpage) {
          while (!feof ($fpage)) { $page .= fgets ($fpage, 1024); }
          // analyse de la rponse du serveur CAS
          if (preg_match('|<cas:authenticationSuccess>.*</cas:authenticationSuccess>|mis',$page)) {
              if(preg_match('|<cas:user>(.*)</cas:user>|',$page,$match)){
                  return($match[1]);
              }
          }
      }
      // problme de validation
      return FALSE;
  }


  $login = authenticate();

  if ($login === FALSE ) {
      echo 'Requte non authentifie (<a href="'.$service.'"><b>Recommencer</b></a>).';
      exit() ;
  }


  //  ce point, lutilisateur est authentifi
  echo 'Utilisateur connect : ' . $login . '(<a href="' . CAS_BASE . '/logout"><b>dconnexion</b></a>)';
?>